// DiskreterIntegrator.java                         MM 2012
import Tools.IO.*;                              // Eingaben

/**
 * Anwendung der Integration bei diskret
 * gegebenen Funktionswerten.
 * @author Monika Meiler
 */
public class DiskreterIntegrator
{
/**
 * Eingabe der Funktionswerte.
 */
  private double[] konsolenEingabe()
  {
    int s = IOTools.readInteger( "Anzahl der Werte: ");
    System.out.println( s);

    double[] y = new double[ s];
    for( int i = 0; i < s; i++)
    {
      y[ i] = IOTools.readDouble( "y[ " + i + "]= ");
      System.out.println( y[ i]);
    }
    return y;
  }

/**
 * Dialog,
 * Eingabe der Funktionswerte, Ausgabe des Flaeche.
 */
  public void dialog()
  {
// Ueberschrift
    System.out.println( "Diskreter Integrator");

// Dialog
    char weiter = 'j';
    do
    {
// Eingabe des Abstandes zwischen den Werten
      System.out.println();
      double h = IOTools.readDouble( "Abstand: ");
      System.out.println( h);

// Eingabe der Messwerte
      System.out.println( "Messwerte");
      double[] y = konsolenEingabe();

// Integral
      Integral integral = new Integral();

// Trapez Integralberechnung
      double ergTrapez = integral.trapez( y, h);
      System.out.println( " Trapez:  F = " + ergTrapez);

// Simpson Integralberechnung
      if( y.length % 2 != 0)
      {
        double ergSimpson = integral.simpson( y, h);
        System.out.println( " Simpson: F = " + ergSimpson);
      }

// Weiter
      weiter = IOTools.readChar( "Neue Messwerte (j/n)? ");
    } while( weiter == 'j');

// Abschluss
    System.out.println();
    System.out.println( "Flaechenberechnung beendet");
  }

/**
 * Starten der Integralberechnung.
 */
  public static void main( String[] args)
  {
// Objekt erzeugen
    DiskreterIntegrator integralBerechner
    = new DiskreterIntegrator();
// Berechnung starten
    integralBerechner.dialog();
  }
}

/* ----------------------------------------------------- */
/*
Diskreter Integrator
Abstand: 1.0
Messwerte
Anzahl der Werte: 5
y[ 0]= 2.0
y[ 1]= 3.0
y[ 2]= 2.0
y[ 3]= 1.0
y[ 4]= 2.0
 Trapez:  F = 8.0
 Simpson: F = 8.0
Neue Messwerte (j/n)?
Abstand: 1.0
Messwerte
Anzahl der Werte: 9
y[ 0]= 2.1
y[ 1]= 1.7
y[ 2]= 1.45
y[ 3]= 1.55
y[ 4]= 1.9
y[ 5]= 2.75
y[ 6]= 3.0
y[ 7]= 3.4
y[ 8]= 4.3
 Trapez:  F = 18.95
 Simpson: F = 18.9
Neue Messwerte (j/n)? 
Flaechenberechnung beendet
*/