// PolynomIntegrator.java                           MM 2013
import Tools.IO.*;                              // Eingaben

/**
 * Programm zur Integrieren von Polynomen.
 * @author Monika Meiler
 */
public class PolynomIntegrator
{
/**
 * Hauptprogramm,
 * startet Dialog zwischen Nutzer und Programm.
 */
  public static void main( String[] args)
  {
// Ueberschrift
    System.out.println( "Polynomintegrator");

// Dialog
    char weiter = 'j';
    do
    {
// Neues Polynom
      System.out.println();
      Polynom polynom = new Polynom();
      if( polynom.konsolenEingabe())     // Eingabe korrekt
      {

// Polynomausgabe
        System.out.println();
        System.out.println( "p( x) = " + polynom);

        do
        {
// Eingabe der Integralparameter
          double a, b;
          do
          {
            System.out.println();
            a = IOTools.readDouble(" Untere Grenze a = ");
            System.out.println( " " + a);
            b = IOTools.readDouble(" Obere  Grenze b = ");
            System.out.println( " " + b);
          } while( a >= b);

// Eingaben der Stuetzstellen
          int s;
          do
          {
            System.out.print
            ( " Anzahl der Stuetzstellen s > 1, ");
            s = IOTools.readInteger( "s = ");
          } while( s < 2);
          System.out.println( " " + s);

// Integral
          Integral integral = new Integral();

// Trapez Integralberechnung
          double ergTrapez
          = integral.trapez( polynom, a, b, s);
          System.out.println
          ( " Trapez:  F = " + ergTrapez);

// Simpson Integralberechnung
          if( s % 2 != 0)
          {
            double ergSimpson
            = integral.simpson( polynom, a, b, s);
            System.out.println
            ( " Simpson: F = " + ergSimpson);
          }
 
// Weiter
          weiter = IOTools.readChar( "Neues Integral (j/n)? ");
        } while( weiter == 'j');

      }
      weiter = IOTools.readChar( "Neues Polynom (j/n)? ");
    } while( weiter == 'j');

// Programm beendet
    System.out.println();
    System.out.println( "Programm beendet");
  }
}

/* ----------------------------------------------------- */
                                               // Testwerte
/*
Polynomintegrator

Polynom 0.0 + 1.0 x^1 + -3.0 x^2 + 2.0 x^3

 Untere Grenze a = 0.0
 Obere  Grenze b = 0.5
 Anzahl der Stuetzstellen s > 1, s = 5
 Trapez:  F = 0.029296875
 Simpson: F = 0.03125

 Untere Grenze a = 0.0
 Obere  Grenze b = 0.5
 Anzahl der Stuetzstellen s > 1, s = 7
 Trapez:  F = 0.03038194444444444
 Simpson: F = 0.03125

 Untere Grenze a = 0.0
 Obere  Grenze b = 1.0
 Anzahl der Stuetzstellen s > 1, s = 5
 Trapez:  F = 0.0
 Simpson: F = 0.0

 Untere Grenze a = 0.0
 Obere  Grenze b = 1.0
 Anzahl der Stuetzstellen s > 1, s = 7
 Trapez:  F = -1.1564823173178713E-17
 Simpson: F = -1.2335811384723961E-17

Polynom 0.0 + 0.0 x^1 + 1.0 x^2

 Untere Grenze a = 0.0
 Obere  Grenze b = 3.0
 Anzahl der Stuetzstellen s > 1, s = 5
 Trapez:  F = 9.28125
 Simpson: F = 9.0

 Untere Grenze a = 0.0
 Obere  Grenze b = 3.0
 Anzahl der Stuetzstellen s > 1, s = 7
 Trapez:  F = 9.125
 Simpson: F = 9.0
*/